"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.attachSockets = attachSockets;

var _keys = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/keys"));

var _debug = _interopRequireDefault(require("debug"));

var _socket = _interopRequireDefault(require("socket.io"));

var d = (0, _debug.default)('cosmos:server:socket');

function attachSockets(server) {
  d('init');
  var io = (0, _socket.default)(server);
  io.on('connection', function (socket) {
    d('connection'); // Forward commands between connected clients. Parties involved can be the
    // - The Cosmos UI, which acts as a remote control
    // - The web iframe or the React Native component loaders

    socket.on('cosmos-cmd', function (msg) {
      d('command %o', msg);
      socket.broadcast.emit('cosmos-cmd', msg);
    });
  });
  return function () {
    var sockets = io.sockets.sockets;
    (0, _keys.default)(sockets).forEach(function (id) {
      sockets[id].disconnect(true);
    });
  };
}