"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getUserWebpackConfig = getUserWebpackConfig;
exports.hasUserCustomWebpackConfig = hasUserCustomWebpackConfig;

var _path = _interopRequireDefault(require("path"));

var _yargs = require("yargs");

var _reactCosmosShared = require("react-cosmos-shared");

var _server = require("react-cosmos-shared/server");

var _defaultWebpackConfig = _interopRequireDefault(require("./default-webpack-config"));

function getUserWebpackConfig(cosmosConfig) {
  var rootPath = cosmosConfig.rootPath,
      webpackConfigPath = cosmosConfig.webpackConfigPath;

  if (hasUserCustomWebpackConfig(cosmosConfig)) {
    var relPath = _path.default.relative(process.cwd(), webpackConfigPath);

    console.log("[Cosmos] Using webpack config found at ".concat(relPath));
    var userConfig = (0, _reactCosmosShared.importModule)(require(webpackConfigPath));

    if (typeof userConfig === 'function') {
      userConfig = userConfig(process.env.NODE_ENV, _yargs.argv);
    }

    return userConfig;
  }

  console.log('[Cosmos] No webpack config found, using defaults');
  return (0, _defaultWebpackConfig.default)(rootPath);
}

function hasUserCustomWebpackConfig(cosmosConfig) {
  return (0, _server.moduleExists)(cosmosConfig.webpackConfigPath);
}